;/***************************************************************************
; *
; *  Copyright (C) 1998-1999 Microsoft Corporation.  All Rights Reserved.
; *
; *  File:       dxfile.inc
; *
; *  Content:    DirectX File public header file
; *
; *  Translated to .ASM by: Siekmanski
; *
; ***************************************************************************/

ifndef __DXFILE_H__
__DXFILE_H__ equ 1

DXFILEFORMAT		typedef DWORD

DXFILEFORMAT_BINARY	equ 0
DXFILEFORMAT_TEXT	equ 1
DXFILEFORMAT_COMPRESSED	equ 2

DXFILELOADOPTIONS	typedef DWORD

DXFILELOAD_FROMFILE	equ 00h
DXFILELOAD_FROMRESOURCE	equ 01h
DXFILELOAD_FROMMEMORY	equ 02h
DXFILELOAD_FROMSTREAM	equ 04h
DXFILELOAD_FROMURL	equ 08h

_DXFILELOADRESOURCE struct
	hModule		DWORD ?
	lpName		DWORD ?
	lpType		DWORD ?
_DXFILELOADRESOURCE ends

DXFILELOADRESOURCE	typedef	_DXFILELOADRESOURCE
LPDXFILELOADRESOURCE	typedef PTR _DXFILELOADRESOURCE

_DXFILELOADMEMORY struct
	lpMemory	DWORD ?
	dSize		DWORD ?
_DXFILELOADMEMORY ends

DXFILELOADMEMORY	typedef _DXFILELOADMEMORY
LPDXFILELOADMEMORY	typedef PTR _DXFILELOADMEMORY

DirectXFileCreate	PROTO :DWORD

_vtIDIRECTXFILEOBJECT_METHODS MACRO CastName:REQ
	&CastName&_GetName		comethod3 ?
	&CastName&_GetId		comethod2 ?
ENDM

IDIRECTXFILEOBJECT_METHODS struct
	_vtIDIRECTXFILEOBJECT_METHODS IDIRECTXFILEOBJECT_METHODS
IDIRECTXFILEOBJECT_METHODS ends


_vtIDirectXFile MACRO CastName:REQ
	_vtIUnknown CastName
	&CastName&_CreateEnumObject	comethod4 ?
	&CastName&_CreateSaveObject	comethod4 ?
	&CastName&_RegisterTemplates	comethod3 ?
ENDM

IDirectXFile struct
	_vtIDirectXFile IDirectXFile
IDirectXFile ends

LPDIRECTXFILE		typedef PTR IDirectXFile

_vtIDirectXFileEnumObject MACRO CastName:REQ
	_vtIUnknown CastName
	&CastName&_GetNextDataObject	comethod2 ?
	&CastName&_GetDataObjectById	comethod3 ?
	&CastName&_GetDataObjectByName	comethod3 ?
ENDM

IDirectXFileEnumObject struct
	_vtIDirectXFileEnumObject IDirectXFileEnumObject
IDirectXFileEnumObject ends

LPDIRECTXFILEENUMOBJECT	typedef PTR IDirectXFileEnumObject

_vtIDirectXFileSaveObject MACRO CastName:REQ
	_vtIUnknown CastName
	&CastName&_SaveTemplates	comethod3 ?
	&CastName&_CreateDataObject	comethod7 ?
	&CastName&_SaveData		comethod2 ?
ENDM

IDirectXFileSaveObject struct
	_vtIDirectXFileSaveObject IDirectXFileSaveObject
IDirectXFileSaveObject ends

LPDIRECTXFILESAVEOBJECT	typedef PTR IDirectXFileSaveObject

_vtIDirectXFileObject MACRO CastName:REQ
	_vtIUnknown CastName
	_vtIDIRECTXFILEOBJECT_METHODS CastName
ENDM

IDirectXFileObject struct
	_vtIDirectXFileObject IDirectXFileObject
IDirectXFileObject ends

LPDIRECTXFILEOBJECT	typedef PTR IDirectXFileObject

_vtIDirectXFileData MACRO CastName:REQ
	_vtIUnknown CastName
	_vtIDIRECTXFILEOBJECT_METHODS CastName
	&CastName&_GetData		comethod4 ?
	&CastName&_GetType		comethod2 ?
	&CastName&_GetNextObject	comethod2 ?
	&CastName&_AddDataObject	comethod2 ?
	&CastName&_AddDataReference	comethod3 ?
	&CastName&_AddBinaryObject	comethod6 ?
ENDM

IDirectXFileData struct
	_vtIDirectXFileData IDirectXFileData
IDirectXFileData ends

LPDIRECTXFILEDATA	typedef PTR IDirectXFileData

_vtIDirectXFileDataReference MACRO CastName:REQ
	_vtIUnknown CastName
	_vtIDIRECTXFILEOBJECT_METHODS CastName
	&CastName&_Resolve		comethod2 ?
ENDM

IDirectXFileDataReference struct
	_vtIDirectXFileDataReference IDirectXFileDataReference
IDirectXFileDataReference ends

LPDIRECTXFILEDATAREFERENCE typedef PTR IDirectXFileDataReference

_vtIDirectXFileBinary MACRO CastName:REQ
	_vtIUnknown CastName
	_vtIDIRECTXFILEOBJECT_METHODS CastName
	&CastName&_GetSize		comethod2 ?
	&CastName&_GetMimeType		comethod2 ?
	&CastName&_Read 		comethod4 ?
ENDM

IDirectXFileBinary struct
	_vtIDirectXFileBinary IDirectXFileBinary
IDirectXFileBinary ends

LPDIRECTXFILEBINARY	typedef PTR IDirectXFileBinary

;/*
; * DirectXFile Object Class Id (for CoCreateInstance())
; */

CLSID_CDirectXFile		TEXTEQU <{04516ec43h,08f20h,011d0h,{09bh,06dh,000h,000h,0c0h,078h,01bh,0c3h}}>

;/*
; * DirectX File Interface GUIDs.
; */

IID_IDirectXFile		TEXTEQU <{03d82ab40h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileEnumObject	TEXTEQU <{03d82ab41h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileSaveObject	TEXTEQU <{03d82ab42h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileObject		TEXTEQU <{03d82ab43h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileData		TEXTEQU <{03d82ab44h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileDataReference	TEXTEQU <{03d82ab45h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>
IID_IDirectXFileBinary		TEXTEQU <{03d82ab46h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>

;/*
; * DirectX File Header template's GUID.
; */

TID_DXFILEHeader		TEXTEQU <{03d82ab43h,062dah,011cfh,{0abh,039h,000h,020h,0afh,071h,0e4h,033h}}>

;/*
; * DirectX File errors.
; */

DXFILE_OK			equ 0

DXFILEERR_BADOBJECT		equ	MAKE_DDHRESULT(850)
DXFILEERR_BADVALUE		equ	MAKE_DDHRESULT(851)
DXFILEERR_BADTYPE		equ	MAKE_DDHRESULT(852)
DXFILEERR_BADSTREAMHANDLE	equ	MAKE_DDHRESULT(853)
DXFILEERR_BADALLOC		equ	MAKE_DDHRESULT(854)
DXFILEERR_NOTFOUND		equ	MAKE_DDHRESULT(855)
DXFILEERR_NOTDONEYET		equ	MAKE_DDHRESULT(856)
DXFILEERR_FILENOTFOUND		equ	MAKE_DDHRESULT(857)
DXFILEERR_RESOURCENOTFOUND	equ	MAKE_DDHRESULT(858)
DXFILEERR_URLNOTFOUND		equ	MAKE_DDHRESULT(859)
DXFILEERR_BADRESOURCE		equ	MAKE_DDHRESULT(860)
DXFILEERR_BADFILETYPE		equ	MAKE_DDHRESULT(861)
DXFILEERR_BADFILEVERSION	equ	MAKE_DDHRESULT(862)
DXFILEERR_BADFILEFLOATSIZE	equ	MAKE_DDHRESULT(863)
DXFILEERR_BADFILECOMPRESSIONTYPE equ	MAKE_DDHRESULT(864)
DXFILEERR_BADFILE		equ	MAKE_DDHRESULT(865)
DXFILEERR_PARSEERROR		equ	MAKE_DDHRESULT(866)
DXFILEERR_NOTEMPLATE		equ	MAKE_DDHRESULT(867)
DXFILEERR_BADARRAYSIZE		equ	MAKE_DDHRESULT(868)
DXFILEERR_BADDATAREFERENCE	equ	MAKE_DDHRESULT(869)
DXFILEERR_INTERNALERROR		equ	MAKE_DDHRESULT(870)
DXFILEERR_NOMOREOBJECTS		equ	MAKE_DDHRESULT(871)
DXFILEERR_BADINTRINSICS		equ	MAKE_DDHRESULT(872)
DXFILEERR_NOMORESTREAMHANDLES	equ	MAKE_DDHRESULT(873)
DXFILEERR_NOMOREDATA		equ	MAKE_DDHRESULT(874)
DXFILEERR_BADCACHEFILE		equ	MAKE_DDHRESULT(875)
DXFILEERR_NOINTERNET		equ	MAKE_DDHRESULT(876)

endif ;/* _DXFILE_H_ */